/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of Remctl.xs. Do not edit this file, edit Remctl.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "lib/Net/Remctl.xs"
/* -*- c -*-
 * Perl bindings for the remctl client library.
 *
 * This is an XS source file, suitable for processing by xsubpp, that
 * generates Perl bindings for the libremctl client library.  It supports
 * both the simplified interface (via a simple remctl call) and the more
 * complex interface (returning a Net::Remctl object which is then used for
 * subsequent calls).
 *
 * The remctl opaque struct is mapped to a Net::Remctl object and supports
 * methods equivalent to the library functions prefixed by remctl_ that take
 * struct remctl * as their first argument.  remctl_new() is mapped to the
 * new method of the class.  remctl_output structs are returned as
 * Net::Remctl::Output objects with accessor functions that return the
 * elements of the remctl_output struct.  The types (output, status, error,
 * and done) are returned as lowercase strings rather than as numeric
 * constants.
 *
 * The simple interface is available via an exported remctl function which
 * returns a Net::Remctl::Result object with accessor functions for the
 * members of the struct.
 *
 * Written by Russ Allbery <eagle@eyrie.org>
 * Copyright 2007, 2008, 2011, 2012, 2014
 *     The Board of Trustees of the Leland Stanford Junior University
 *
 * See LICENSE for licensing terms.
 */

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#include <errno.h>
#include <time.h>

#include <remctl.h>

/*
 * These typedefs are needed for xsubpp to work its magic with type
 * translation to Perl objects.
 */
typedef struct remctl *         Net__Remctl;
typedef struct remctl_result *  Net__Remctl__Result;
typedef struct remctl_output *  Net__Remctl__Output;

/* Map the remctl_output type constants to strings. */
const struct {
    enum remctl_output_type type;
    const char *name;
} OUTPUT_TYPE[] = {
    { REMCTL_OUT_OUTPUT, "output" },
    { REMCTL_OUT_STATUS, "status" },
    { REMCTL_OUT_ERROR,  "error"  },
    { REMCTL_OUT_DONE,   "done"   },
    { 0,                 NULL     }
};

/* Used to check that an object argument to a function is not NULL. */
#define CROAK_NULL(o, t, f)                     \
    do {                                        \
        if ((o) == NULL)                        \
            croak(t " object is undef in " f);  \
    } while (0);
#define CROAK_NULL_SELF(o, t, f) CROAK_NULL((o), t, t "::" f)


/* XS code below this point. */

#line 80 "lib/Net/Remctl.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 132 "lib/Net/Remctl.c"

XS(XS_Net__Remctl_remctl); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_remctl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       croak_xs_usage(cv,  "host, port, principal, ...");
    {
	const char *	host = (const char *)SvPV_nolen(ST(0));
	unsigned short	port = (unsigned short)SvUV(ST(1));
	const char *	principal = (const char *)SvPV_nolen(ST(2));
#line 80 "lib/Net/Remctl.xs"
    size_t count = items - 3;
    size_t i;
    const char **command;
#line 152 "lib/Net/Remctl.c"
	Net__Remctl__Result	RETVAL;
#line 84 "lib/Net/Remctl.xs"
    if (items <= 3)
        croak("Too few arguments to Net::Remctl::remctl");
    if (principal != NULL && *principal == '\0')
        principal = NULL;
    command = calloc(count + 1, sizeof(char *));
    if (command == NULL)
        croak("Error allocating memory in Net::Remctl::remctl: %s",
              strerror(errno));
    for (i = 0; i <= count; i++)
        command[i] = SvPV_nolen(ST(i + 3));
    command[count] = NULL;
    RETVAL = remctl(host, port, principal, command);
    if (RETVAL == NULL)
        croak("Error creating Net::Remctl::Result object: %s",
              strerror(errno));
    free(command);
#line 171 "lib/Net/Remctl.c"
	ST(0) = sv_newmortal();
    if (RETVAL == NULL)
        ST(0) = &PL_sv_undef;
    else
        sv_setref_pv(ST(0), "Net::Remctl::Result", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	const char *	class = (const char *)SvPV_nolen(ST(0));
	Net__Remctl	RETVAL;
#line 108 "lib/Net/Remctl.xs"
    RETVAL = remctl_new();
    if (RETVAL == NULL)
        croak("Error creating %s object: %s", class, strerror(errno));
#line 199 "lib/Net/Remctl.c"
	ST(0) = sv_newmortal();
    if (RETVAL == NULL)
        ST(0) = &PL_sv_undef;
    else
        sv_setref_pv(ST(0), "Net::Remctl", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl	self;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 119 "lib/Net/Remctl.xs"
    if (self != NULL)
        remctl_close(self);
#line 234 "lib/Net/Remctl.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__Remctl_set_ccache); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_set_ccache)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, ccache");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
	const char *	ccache = (const char *)SvPV_nolen(ST(1));

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 128 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl", "set_ccache");
    if (remctl_set_ccache(self, ccache))
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 270 "lib/Net/Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_set_source_ip); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_set_source_ip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, source");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
	const char *	source = (const char *)SvPV_nolen(ST(1));

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 140 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl", "set_source_ip");
    if (remctl_set_source_ip(self, source))
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 307 "lib/Net/Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_set_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
	time_t	timeout = (time_t)SvNV(ST(1));

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 152 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl", "set_source_timeout");
    if (remctl_set_timeout(self, timeout))
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 344 "lib/Net/Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "self, host, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
	const char *	host = (const char *)SvPV_nolen(ST(1));
#line 164 "lib/Net/Remctl.xs"
    size_t count = items - 2;
    unsigned short port = 0;
    const char *principal = NULL;
#line 370 "lib/Net/Remctl.c"

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 168 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl", "open");
    if (count > 2)
        croak("Too many arguments to Net::Remctl::open");
    if (count >= 1)
        port = SvUV(ST(2));
    if (count >= 2 && ST(3) != &PL_sv_undef) {
        principal = SvPV_nolen(ST(3));
        if (*principal == '\0')
            principal = NULL;
    }
    if (remctl_open(self, host, port, principal))
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 395 "lib/Net/Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_command); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_command)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
#line 188 "lib/Net/Remctl.xs"
    struct iovec *args;
    size_t count = items - 1;
    size_t i;
    int status;
#line 421 "lib/Net/Remctl.c"

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 193 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl", "command");
    if (count == 0)
        croak("Too few arguments to Net::Remctl::command");
    args = calloc(count, sizeof(struct iovec));
    if (args == NULL)
        croak("Error allocating memory in Net::Remctl::command: %s",
              strerror(errno));
    for (i = 1; i <= count; i++)
        args[i - 1].iov_base = SvPV(ST(i), args[i - 1].iov_len);
    status = remctl_commandv(self, args, count);
    free(args);
    if (status)
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 447 "lib/Net/Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_output); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_output)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl	self;
	Net__Remctl__Output	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };

	RETVAL = remctl_output(self);
	ST(0) = sv_newmortal();
    if (RETVAL == NULL)
        ST(0) = &PL_sv_undef;
    else
        sv_setref_pv(ST(0), "Net::Remctl::Output", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl_noop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_noop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 219 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl", "noop");
    if (remctl_noop(self))
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 517 "lib/Net/Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl	self;
	const char *	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };

	RETVAL = remctl_error(self);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Result	self;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 237 "lib/Net/Remctl.xs"
    remctl_result_free(self);
#line 578 "lib/Net/Remctl.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__Remctl__Result_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Result	self;
	char *	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 244 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Result", "error");
    RETVAL = self->error;
#line 610 "lib/Net/Remctl.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_stdout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_stdout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Result	self;
	SV *	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 254 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Result", "stdout");
    if (self->stdout_buf == NULL)
        XSRETURN_UNDEF;
    else
        RETVAL = newSVpvn(self->stdout_buf, self->stdout_len);
#line 645 "lib/Net/Remctl.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_stderr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_stderr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Result	self;
	SV *	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 267 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Result", "stderr");
    if (self->stderr_buf == NULL)
        XSRETURN_UNDEF;
    else
        RETVAL = newSVpvn(self->stderr_buf, self->stderr_len);
#line 681 "lib/Net/Remctl.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Result	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 280 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Result", "status");
    RETVAL = self->status;
#line 715 "lib/Net/Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Output	self;
#line 292 "lib/Net/Remctl.xs"
    size_t i;
#line 736 "lib/Net/Remctl.c"
	const char *	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 294 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Output", "type");
    RETVAL = NULL;
    for (i = 0; OUTPUT_TYPE[i].name != NULL; i++)
        if (OUTPUT_TYPE[i].type == self->type) {
            RETVAL = OUTPUT_TYPE[self->type].name;
            break;
        }
#line 756 "lib/Net/Remctl.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Output	self;
	SV *	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 309 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Output", "data");
    if (self->data == NULL)
        XSRETURN_UNDEF;
    else
        RETVAL = newSVpvn(self->data, self->length);
#line 791 "lib/Net/Remctl.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_length)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Output	self;
	size_t	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 322 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Output", "length");
    RETVAL = self->length;
#line 825 "lib/Net/Remctl.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Output	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 332 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Output", "stream");
    RETVAL = self->stream;
#line 858 "lib/Net/Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Output	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 342 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Output", "status");
    RETVAL = self->status;
#line 891 "lib/Net/Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Net__Remctl__Output	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 352 "lib/Net/Remctl.xs"
    CROAK_NULL_SELF(self, "Net::Remctl::Output", "error");
    RETVAL = self->error;
#line 924 "lib/Net/Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Net__Remctl); /* prototype to pass -Wmissing-prototypes */
XS(boot_Net__Remctl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Net::Remctl::remctl", XS_Net__Remctl_remctl, file);
        newXS("Net::Remctl::new", XS_Net__Remctl_new, file);
        newXS("Net::Remctl::DESTROY", XS_Net__Remctl_DESTROY, file);
        newXS("Net::Remctl::set_ccache", XS_Net__Remctl_set_ccache, file);
        newXS("Net::Remctl::set_source_ip", XS_Net__Remctl_set_source_ip, file);
        newXS("Net::Remctl::set_timeout", XS_Net__Remctl_set_timeout, file);
        newXS("Net::Remctl::open", XS_Net__Remctl_open, file);
        newXS("Net::Remctl::command", XS_Net__Remctl_command, file);
        newXS("Net::Remctl::output", XS_Net__Remctl_output, file);
        newXS("Net::Remctl::noop", XS_Net__Remctl_noop, file);
        newXS("Net::Remctl::error", XS_Net__Remctl_error, file);
        newXS("Net::Remctl::Result::DESTROY", XS_Net__Remctl__Result_DESTROY, file);
        newXS("Net::Remctl::Result::error", XS_Net__Remctl__Result_error, file);
        newXS("Net::Remctl::Result::stdout", XS_Net__Remctl__Result_stdout, file);
        newXS("Net::Remctl::Result::stderr", XS_Net__Remctl__Result_stderr, file);
        newXS("Net::Remctl::Result::status", XS_Net__Remctl__Result_status, file);
        newXS("Net::Remctl::Output::type", XS_Net__Remctl__Output_type, file);
        newXS("Net::Remctl::Output::data", XS_Net__Remctl__Output_data, file);
        newXS("Net::Remctl::Output::length", XS_Net__Remctl__Output_length, file);
        newXS("Net::Remctl::Output::stream", XS_Net__Remctl__Output_stream, file);
        newXS("Net::Remctl::Output::status", XS_Net__Remctl__Output_status, file);
        newXS("Net::Remctl::Output::error", XS_Net__Remctl__Output_error, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

